diff -crN nakedmudv1.4/src/time/time.c nakedmudv1.5/src/time/time.c
*** nakedmudv1.4/src/time/time.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/time/time.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 102,108 ****
  
  STORAGE_SET *timeAuxDataStore(TIME_AUX_DATA *data) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "night_desc", data->night_desc, NULL);
    return set;
  }
  
--- 102,108 ----
  
  STORAGE_SET *timeAuxDataStore(TIME_AUX_DATA *data) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "night_desc", data->night_desc);
    return set;
  }
  
***************
*** 174,192 ****
  
    // save our time data to file
    STORAGE_SET *set = new_storage_set();
!   store_int(set, "hour",         curr_hour,         NULL);
!   store_int(set, "day_of_week",  curr_day_of_week,  NULL);
!   store_int(set, "day_of_month", curr_day_of_month, NULL);
!   store_int(set, "month",        curr_month,        NULL);
!   store_int(set, "year",         curr_year,         NULL);
    storage_write(set, TIME_FILE);
    storage_close(set);
- 
-   // throw ourself back into the event queue
-   start_event(NULL,
- 	      TIME_UPDATE_DELAY,
- 	      handle_time_update,
- 	      NULL, NULL, NULL);
  }
  
  
--- 174,186 ----
  
    // save our time data to file
    STORAGE_SET *set = new_storage_set();
!   store_int(set, "hour",         curr_hour);
!   store_int(set, "day_of_week",  curr_day_of_week);
!   store_int(set, "day_of_month", curr_day_of_month);
!   store_int(set, "month",        curr_month);
!   store_int(set, "year",         curr_year);
    storage_write(set, TIME_FILE);
    storage_close(set);
  }
  
  
***************
*** 216,225 ****
  				       timeAuxDataStore, timeAuxDataRead));
  
    // start our time updater
!   start_event(NULL,
! 	      TIME_UPDATE_DELAY,
! 	      handle_time_update,
! 	      NULL, NULL, NULL);
  }
  
  
--- 210,216 ----
  				       timeAuxDataStore, timeAuxDataRead));
  
    // start our time updater
!   start_update(NULL, TIME_UPDATE_DELAY, handle_time_update, NULL, NULL, NULL);
  }
  
  
diff -crN nakedmudv1.4/src/utils.c nakedmudv1.5/src/utils.c
*** nakedmudv1.4/src/utils.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/utils.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 25,31 ****
  #include "dialog.h"
  #include "event.h"
  #include "action.h"
- #include "help.h"
  
  
  // optional modules
--- 25,30 ----
***************
*** 91,101 ****
  #endif
    interrupt_events_involving(ch);
  
- #ifdef MODULE_FIGHT
-   stop_all_targetting(ch);
-   stop_fight(ch);
- #endif
- 
    // unequip everything the character is wearing
    // and send it to inventory
    unequip_all(ch);
--- 90,95 ----
***************
*** 157,166 ****
  
  
  /*
!  * Loading of help files, areas, etc, at boot time.
   */
  void load_muddata(bool fCopyOver) {  
-   load_helps();
    gameworld = worldLoad(WORLD_PATH);
    if(gameworld == NULL) {
      log_string("ERROR: Could not boot game world.");
--- 151,159 ----
  
  
  /*
!  * load the world and its inhabitants, as well as other misc game data
   */
  void load_muddata(bool fCopyOver) {  
    gameworld = worldLoad(WORLD_PATH);
    if(gameworld == NULL) {
      log_string("ERROR: Could not boot game world.");
***************
*** 330,335 ****
--- 323,330 ----
      return TRUE;
    if(poscmp(charGetPos(ch), POS_SLEEPING) <= 0)
      return FALSE;
+   if(charGetImmInvis(target) > charGetLevel(ch))
+     return FALSE;
  
    return TRUE;
  }
***************
*** 857,862 ****
--- 852,892 ----
  
  
  //
+ // print the string on the buffer, centered for a line of length linelen.
+ // if border is TRUE, put a border to either side of the string.
+ //
+ void center_string(char *buf, const char *string, int linelen, int buflen, 
+ 		   bool border) {
+   static char fmt[32];
+   int str_len = strlen(string);
+   int spaces  = (linelen - str_len)/2;
+ 
+   if(border) {
+     int i, buf_i = 0;
+     sprintf(fmt, "{g%%-%ds[{c", spaces-2);
+     buf_i  = snprintf(buf, buflen, fmt, " ");
+     // replace all of the spaces with -
+     for(i = 0; buf[i] != '\0'; i++) if(buf[i] == ' ') buf[i] = '-';
+ 
+     buf_i += snprintf(buf+buf_i, buflen-buf_i, " %s ", string);
+     sprintf(fmt, "{g]%%-%ds\r\n", 
+ 	    spaces-2 + (((linelen-str_len) % 2) == 1 ? 1 : 0));
+ 
+     i = buf_i;
+     buf_i += snprintf(buf+buf_i, buflen-buf_i, fmt, " ");
+     // replace all of the spaces with -
+     for(; buf[i] != '\0'; i++) if(buf[i] == ' ') buf[i] = '-';
+   }
+   else {
+     int buf_i = 0;
+     sprintf(fmt, "%%-%ds", spaces);
+     buf_i  = snprintf(buf, buflen, fmt, " ");
+     buf_i += snprintf(buf+buf_i, buflen-buf_i, "%s\r\n", string);
+   }
+ }
+ 
+ 
+ //
  // fill up the buffer with characters until
  // a newline is reached, or we hit our critical
  // length. Return how many characters were read
***************
*** 1163,1172 ****
  }
  
  
! void show_list(CHAR_DATA *ch, LIST *list, 
! 	       void *descriptor, void *multi_descriptor) {
    const char             *(* desc_func)(void *) = descriptor;
    const char            *(* multi_desc)(void *) = multi_descriptor;
  
    int i;
    int size = listSize(list);
--- 1193,1203 ----
  }
  
  
! void show_list(CHAR_DATA *ch, LIST *list, void *descriptor, 
! 	       void *multi_descriptor, void *vnum_getter) {
    const char             *(* desc_func)(void *) = descriptor;
    const char            *(* multi_desc)(void *) = multi_descriptor;
+   int                    (*  vnum_func)(void *) = vnum_getter;
  
    int i;
    int size = listSize(list);
***************
*** 1205,1218 ****
      // we've run into the end of the list
      if(things[i] == NULL)
        break;
-     if(counts[i] == 1)
-       send_to_char(ch, "%s\r\n", desc_func(things[i]));
-     else if(multi_desc == NULL || !*multi_desc(things[i]))
-       send_to_char(ch, "(%d) %s\r\n", counts[i], desc_func(things[i]));
      else {
!       char fmt[SMALL_BUFFER];
!       sprintf(fmt, "%s\r\n", multi_desc(things[i]));
!       send_to_char(ch, fmt, counts[i]);
      }
    }
  }
--- 1236,1258 ----
      // we've run into the end of the list
      if(things[i] == NULL)
        break;
      else {
!       char vnum_buf[20];
!       if(charGetLevel(ch) < LEVEL_BUILDER || vnum_func == NULL)
! 	*vnum_buf = '\0';
!       else
! 	sprintf(vnum_buf, "[%d] ", vnum_func(things[i]));
! 
!       if(counts[i] == 1)
! 	send_to_char(ch, "%s%s\r\n", vnum_buf, desc_func(things[i]));
!       else if(multi_desc == NULL || !*multi_desc(things[i]))
! 	send_to_char(ch, "%s(%d) %s\r\n", vnum_buf, 
! 		     counts[i], desc_func(things[i]));
!       else {
! 	char fmt[SMALL_BUFFER];
! 	sprintf(fmt, "%s%s\r\n", vnum_buf, multi_desc(things[i]));
! 	send_to_char(ch, fmt, counts[i]);
!       }
      }
    }
  }
***************
*** 1263,1270 ****
  
  const char *custom_prompt(CHAR_DATA *ch) {
    static char prompt[MAX_BUFFER];
!   *prompt = '\0';
!   strcat(prompt, "\r\nprompt> ");
!     
    return prompt;
  }
--- 1303,1308 ----
  
  const char *custom_prompt(CHAR_DATA *ch) {
    static char prompt[MAX_BUFFER];
!   sprintf(prompt, "\r\nprompt> ");
    return prompt;
  }
diff -crN nakedmudv1.4/src/utils.h nakedmudv1.5/src/utils.h
*** nakedmudv1.4/src/utils.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/utils.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 101,107 ****
  void format_string        (char **ptr_string, int max_width, 
  		          unsigned int maxlen, bool indent);
  int  count_letters        (const char *string, const char ch, const int strlen);
! int   fgetline            (FILE *file, char *p, int maxlen);
  
  
  
--- 101,109 ----
  void format_string        (char **ptr_string, int max_width, 
  		          unsigned int maxlen, bool indent);
  int  count_letters        (const char *string, const char ch, const int strlen);
! int  fgetline             (FILE *file, char *p, int maxlen);
! void center_string        (char *buf, const char *string, int linelen, 
! 			   int buflen, bool border);
  
  
  
***************
*** 138,143 ****
--- 140,153 ----
        mapIteratorNext(it), \
        key = mapIteratorCurrentKey(it), val = mapIteratorCurrentVal(it))
  
+ // iterate across all the elements in a set
+ #define ITERATE_SET(elem, it) \
+   for(elem = setIteratorCurrent(it); \
+       elem != NULL; \
+       setIteratorNext(it), elem = setIteratorCurrent(it))
+ 
+ 
+ 
  
  //
  // count how many objects are in the list, that meet our critereon.
***************
*** 199,206 ****
  // multi-descriptor is a pointer to the function that gets a copy of the
  // thing's description if there is more than 1 copy of it in the list.
  //
! void show_list(CHAR_DATA *ch, LIST *list, 
! 	       void *descriptor, void *multi_descriptor);
  
  
  //
--- 209,220 ----
  // multi-descriptor is a pointer to the function that gets a copy of the
  // thing's description if there is more than 1 copy of it in the list.
  //
! // vnum_getter is a pointer to a function that returns the thing's vnum for
! // displaying to players of builder level and above. vnum_getter can be NULL 
! // to display no vnums.
! //
! void show_list(CHAR_DATA *ch, LIST *list, void *descriptor, 
! 	       void *multi_descriptor, void *vnum_getter);
  
  
  //
diff -crN nakedmudv1.4/src/world.c nakedmudv1.5/src/world.c
*** nakedmudv1.4/src/world.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/world.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 185,191 ****
    char buf[MAX_BUFFER];
    STORAGE_SET       *set = new_storage_set();
    STORAGE_SET_LIST *list = new_storage_list();
!   store_list(set, "zones", list, NULL);
  
    LIST_ITERATOR *zone_i = newListIterator(world->zones);
    ZONE_DATA       *zone = NULL;
--- 185,191 ----
    char buf[MAX_BUFFER];
    STORAGE_SET       *set = new_storage_set();
    STORAGE_SET_LIST *list = new_storage_list();
!   store_list(set, "zones", list);
  
    LIST_ITERATOR *zone_i = newListIterator(world->zones);
    ZONE_DATA       *zone = NULL;
***************
*** 198,204 ****
  
      if(zoneSave(zone, buf)) {
        STORAGE_SET *zone_set = new_storage_set();
!       store_int(zone_set, "vnum", zoneGetVnum(zone), NULL);
        storage_list_put(list, zone_set);
      }
    }
--- 198,204 ----
  
      if(zoneSave(zone, buf)) {
        STORAGE_SET *zone_set = new_storage_set();
!       store_int(zone_set, "vnum", zoneGetVnum(zone));
        storage_list_put(list, zone_set);
      }
    }
diff -crN nakedmudv1.4/src/zone.c nakedmudv1.5/src/zone.c
*** nakedmudv1.4/src/zone.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/zone.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 13,21 ****
  #include "object.h"
  #include "character.h"
  #include "room.h"
- #include "zone.h"
  #include "utils.h"
  #include "dialog.h"
  
  #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
--- 13,22 ----
  #include "object.h"
  #include "character.h"
  #include "room.h"
  #include "utils.h"
+ #include "auxiliary.h"
  #include "dialog.h"
+ #include "zone.h"
  
  #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
***************
*** 40,47 ****
--- 41,51 ----
  
    int pulse_timer;  // the timer duration
    int pulse;        // how far down have we gone?
+ 
+   HASHTABLE            * auxiliary_data; // additional data installed on us
  };
  
+ 
  ZONE_DATA *newZone(zone_vnum vnum, room_vnum min, room_vnum max) {
    ZONE_DATA *zone = malloc(sizeof(ZONE_DATA));
    zone->name    = strdup("");
***************
*** 64,69 ****
--- 68,75 ----
    zone->mob_protos = newPropertyTable(charGetVnum,    1 + (max-min)/5);
    zone->obj_protos = newPropertyTable(objGetVnum,    1 + (max-min)/5);
  
+   zone->auxiliary_data = newAuxiliaryData(AUXILIARY_TYPE_ZONE);
+ 
    return zone;
  }
  
***************
*** 82,87 ****
--- 88,94 ----
    to->max  = from->max;
    to->pulse_timer = from->pulse_timer;
    to->pulse = from->pulse;
+   auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
  }
  
  void deleteZone(ZONE_DATA *zone){ 
***************
*** 95,100 ****
--- 102,109 ----
    deletePropertyTable(zone->mob_protos);
    deletePropertyTable(zone->obj_protos);
  
+   deleteAuxiliaryData(zone->auxiliary_data);
+ 
    //*******************************************************************
    // The only time we're deleting a zone is when we're editing the copy
    // in OLC. So, We don't want to delete any of the zone's content when
***************
*** 158,163 ****
--- 167,177 ----
    zoneSetName(zone,   read_string(set, "name"));
    zoneSetDescription(zone,   read_string(set, "desc"));
    zoneSetEditors(zone,read_string(set, "editors"));
+ 
+   deleteAuxiliaryData(zone->auxiliary_data);
+   zone->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
+ 					   AUXILIARY_TYPE_ZONE);
+ 
    storage_close(set);
  
    // now, load all of the content data
***************
*** 204,210 ****
    STORAGE_SET       *set = new_storage_set();
    STORAGE_SET_LIST *list = new_storage_list();
    void             *data = NULL;
!   store_list(set, "list", list, NULL);
  
    int i = zoneGetMinBound(zone);
    for(; i <= zoneGetMaxBound(zone); i++) {
--- 218,224 ----
    STORAGE_SET       *set = new_storage_set();
    STORAGE_SET_LIST *list = new_storage_list();
    void             *data = NULL;
!   store_list(set, "list", list);
  
    int i = zoneGetMinBound(zone);
    for(; i <= zoneGetMaxBound(zone); i++) {
***************
*** 225,237 ****
    // first, for our zone data
    sprintf(fname, "%s/zone", dirpath);
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum",        zone->vnum,        NULL);
!   store_int   (set, "min",         zone->min,         NULL);
!   store_int   (set, "max",         zone->max,         NULL);
!   store_int   (set, "pulse_timer", zone->pulse_timer, NULL);
!   store_string(set, "name",        zone->name,        NULL);
!   store_string(set, "desc",        zone->desc,        NULL);
!   store_string(set, "editors",     zone->editors,     NULL);
    storage_write(set, fname);
    storage_close(set);
  
--- 239,252 ----
    // first, for our zone data
    sprintf(fname, "%s/zone", dirpath);
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum",        zone->vnum);
!   store_int   (set, "min",         zone->min);
!   store_int   (set, "max",         zone->max);
!   store_int   (set, "pulse_timer", zone->pulse_timer);
!   store_string(set, "name",        zone->name);
!   store_string(set, "desc",        zone->desc);
!   store_string(set, "editors",     zone->editors);
!   store_set   (set, "auxiliary",   auxiliaryDataStore(zone->auxiliary_data));
    storage_write(set, fname);
    storage_close(set);
  
***************
*** 371,376 ****
--- 386,395 ----
    return zone->max;
  }
  
+ void *zoneGetAuxiliaryData(const ZONE_DATA *zone, char *name) {
+   return hashGet(zone->auxiliary_data, name);
+ }
+ 
  room_vnum getFreeRoomVnum(ZONE_DATA *zone) {
    zone_vnum i;
    for(i = zone->min; i <= zone->max; i++)
***************
*** 457,462 ****
--- 476,484 ----
  }
  
  void zoneSetPulseTimer(ZONE_DATA *zone, int timer) { 
+   // if we normally do not reset, change that
+   if(zone->pulse_timer < 0)
+     zone->pulse = timer;
    zone->pulse_timer = timer;
  }
  
diff -crN nakedmudv1.4/src/zone.h nakedmudv1.5/src/zone.h
*** nakedmudv1.4/src/zone.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/zone.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 99,105 ****
  OBJ_DATA   *zoneGetObj(ZONE_DATA *zone, obj_vnum obj);
  SCRIPT_DATA *zoneGetScript(ZONE_DATA *zone, script_vnum script);
  DIALOG_DATA *zoneGetDialog(ZONE_DATA *zone, dialog_vnum script);
! 
  
  void zoneSetVnum(ZONE_DATA *zone, zone_vnum vnum);
  void zoneSetMinBound(ZONE_DATA *zone, room_vnum min);
--- 99,105 ----
  OBJ_DATA   *zoneGetObj(ZONE_DATA *zone, obj_vnum obj);
  SCRIPT_DATA *zoneGetScript(ZONE_DATA *zone, script_vnum script);
  DIALOG_DATA *zoneGetDialog(ZONE_DATA *zone, dialog_vnum script);
! void        *zoneGetAuxiliaryData(const ZONE_DATA *zone, char *name);
  
  void zoneSetVnum(ZONE_DATA *zone, zone_vnum vnum);
  void zoneSetMinBound(ZONE_DATA *zone, room_vnum min);
diff -crN nakedmudv1.4/TODO nakedmudv1.5/TODO
*** nakedmudv1.4/TODO	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/TODO	2010-11-01 15:54:17.000000000 -0500
***************
*** 1,18 ****
  GEOFF'S TO DO LIST
  +-- KNOWN BUGS
  
  
  +-- NOT COMPLETE
!   * remove the EXIT_DATA parameter from the script functions
!   * write helpfiles, create a better helpfile system, and do hedit
    * condense normal and special exits in rooms
    * soft-code chat channels
    * random dungeon generator
-   * spellchecking in the text editor
    * mounts and vehicles
    * being able to stream music would be cool...
    * clean up and document resedit in the olc module
-   * tracking and path following
    * shops (for mobiles and players)
    * customized prompts
    * DOCUMENT DOCUMENT DOCUMENT!! Most of the major headers need full
--- 1,20 ----
  GEOFF'S TO DO LIST
  +-- KNOWN BUGS
+   * moving via tracking will not trigger enter/exit scripts
  
  
  +-- NOT COMPLETE
!   * spellchecking in the text editor
!   * Redo OLC so that if a module uses OLC, it can add the relevant functions
!     from its own module.
!   * Devise something to replace bitvectors that is a bit more amenable to
!     keeping things modular.
    * condense normal and special exits in rooms
    * soft-code chat channels
    * random dungeon generator
    * mounts and vehicles
    * being able to stream music would be cool...
    * clean up and document resedit in the olc module
    * shops (for mobiles and players)
    * customized prompts
    * DOCUMENT DOCUMENT DOCUMENT!! Most of the major headers need full
***************
*** 27,41 ****
  
  
  +-- NEEDS EXTRA WORK
    * debug dialogs. Also have a new addition, STORY for temporally extended
      responses
  
  
  +-- NEEDS DEBUGGING
-   * containers
-   * room reset
-   * Make sure extract obj/char is catching everything, and is running well
-   * Delayed action and event handlers
-   * Generic find algorithm
-   * Bodytypes, especially when setting a character's bodytype anew
    * text editor
--- 29,41 ----
  
  
  +-- NEEDS EXTRA WORK
+   * write helpfiles, create a better helpfile system, and do hedit
+   * tracking and path following -> daily routines, and patrols
+   * displaying mob/obj/room/exit vnums for immortals -> do we want to also
+     display this stuff for furniture?
    * debug dialogs. Also have a new addition, STORY for temporally extended
      responses
  
  
  +-- NEEDS DEBUGGING
    * text editor
